(clear-all)
(defvar *DSFState* nil)
(defvar *Amount* nil)
(defvar *Time* nil)
(defvar *Goal* nil)
(defvar *UI* nil)
(defvar *UO* nil)
(defvar *EI* nil)
(defvar *EO* nil)
(defvar *Data* nil)
(defvar *DSF-Counter* 0)

(defun collect-data()
  
  (experiment "Varun1" "BATCH" "ACTR")

  )


(defun experiment(name version-name ACTR-name)
  (setf *DSFState* nil)
  (setf *Amount* nil)
  (setf *Time* nil)
  (setf *Goal* nil)
  (setf *UI* nil)
  (setf *UO* nil)
  (setf *EI* nil)
  (setf *EO* nil)
  (setf *Data* nil)
  (setf *DSF-Counter* 0)
  (reset)
  (connsoc "ENTRY-ID" name "VERSION" version-name ACTR-name)
  (setting-variables)
  (set-chunk-focus)
  (run 5000 :real-time t))
  
(defun connsoc(entry-id name version version-type ACTR-name)
(setf initial-string  (format nil "~a ~a ~a ~a ~a" entry-id name version version-type ACTR-name))
   (defparameter *v* (uni-make-socket "localhost" 9548))
(uni-send-string *v* initial-string))

(defun setting-variables ()  
  (setf *data* (uni-socket-read-line *v*))
  (setf *data* (read-from-string *data*))
  #|(format t "~a" *data*)|#	
  (setf *DSFState* (first *data*))
  (setf *Time* (third *data*))
  (setf *Goal* (fifth *data*))
  (setf *Amount* (seventh *data*))
  (setf *UI* (nth 13 *data*))
  (setf *UO* (nth 15 *data*))
  (setf *EI* (ninth *data*))
(setf *EO* (nth 10 *data*)))


(defun def-chunk ()
  (define-chunks-fct (list (list 'isa 'DSF-variables 
	'ACTR-State 'recog 'DSF-State  *DSFState* 'time *Time* 'goal *Goal* 'amount *AMOUNT* 
    'ei *EI* 'eo *EO* 'ui nil 'uo nil))))
  
(defun set-chunk-focus()
  (goal-focus-fct  (first (def-chunk))))

(defun ad-cn ()  
(setf *DSF-Counter*  (+ *DSF-Counter* 1))
)

(define-model DSFClient
    
(sgp :v t :trace-detail medium :ncnar nil) 

(chunk-type DSF-variables ACTR-State DSF-State TIME GOAL AMOUNT EI EO UI UO)

(add-dm
 (State isa chunk)
 (recog isa chunk)
 (execute isa chunk)
 (first-heuristic isa chunk)
 (end-program isa chunk)
 (stopped isa chunk))

(p First    
   =goal>
   isa DSF-variables
   ACTR-State recog
   time 0
   
   ==>
   
   !eval! (ad-cn)
   !eval! (format t "*DSF-Counter* ~a~%" *DSF-Counter*)
   
   =goal>
   ACTR-State first-heuristic)
   
(p Alternate    
   =goal>
   isa DSF-variables
   ACTR-State recog
   
   ==>
   
   !eval! (ad-cn)
   !eval! (format t "*DSF-Counter* ~a~%" *DSF-Counter*)
   
   =goal>
   ACTR-State first-heuristic)

(p End-Of-DSF    
   
   =goal>
   isa DSF-Variables
   ACTR-state recog   
   !eval!  (equalp *DSF-Counter* 100)
   
   ==>
   
   =goal>
   ACTR-State end-program) 


(p Stop    
   
   =goal>
   isa DSF-Variables
   ACTR-state end-program 

   ==>
   
   =goal>
   ACTR-state stopped
   
   !eval!  (uni-send-string *v* (format nil "QUIT"))
   !eval! (close *v*))
  
   
(p Heuristic
    
   =goal>
   isa DSF-variables
   ACTR-State first-heuristic
   
   ==>
   
   !bind! =uit 1.0
   
   =goal>
   ACTR-State execute
   ui =uit
   uo =uit
   ei =uit
   eo =uit)


(p Execution
   
   =goal>
   isa DSF-variables
   ACTR-State execute
   ui =ui
   uo =uo
   ei =ei
   eo =eo
   
   ==>
   
   !eval!  (uni-send-string *v* (format nil "DECISION UI ~d UO ~d EI ~d EO ~d" =ui =uo =ei =eo))
   !eval! (setting-variables)
   !eval! (format t "~a" *data*)
   !eval! (set-chunk-focus)   
   
   =goal>
   ACTR-State recog)

(spp First :at 1)
(spp Alternate :at 1)
(spp End-Of-DSF :at 1)
(spp Execution :at 1)
(spp Heuristic :at 1)
(setf *actr-enabled-p* t)

) 